/********************************************************************************
|  CLASS:         TLS2118 - Getting Started with MPLAB C for PIC18
|  PROGRAM:       Lab4.c   
|  DESCRIPTION:   First MPLAB C18 project to test whether everything is working
|  REQUIREMENTS:  TLS2118.lib 
|                              
| 
|  REVISION HISTORY:
|  30 APR 2009    Rob Ostapiuk v1.0
********************************************************************************/
#include <p18cxxx.h>
#include "P18F_LCD.h"
#include <stdlib.h>
#include <timers.h>
#include <adc.h>

#pragma config OSC=INTIO7, WDT=OFF, BOREN = ON, BORV = 1, LVP=OFF, PBADEN=OFF, XINST = OFF, MCLRE = ON

#define	TIMER1_1ms_VALUE 	65536-(1000*2)+96		//	CPU runs @ 8Mhz , 2MHZ Fcy , 1ms = 1000 us


//********* ƪ쫬ŧi **********
//
void	IntHighVector(void);
void	HighISR(void) ;
void	IntHighVector(void);
void	Update_ADC(unsigned int) ;
void 	Timer1_Initial(void);
void 	ADC_Initial(void);

//*********** ܼƩwq  *************
//
unsigned char 	i;
unsigned int	Timer1_Acc = 0 ;
unsigned char	FLAG_1ms ;

char			ASCII_Buffer[10] ;

//******** uv_{iJI  ******
//												// ץȬO MPLAB SIM + Stopwatch ҺXӪ
#pragma	code	HighVector = 0x0008 
void	IntHighVector(void)
{
	_asm	goto	HighISR		_endasm
}	

//******** uv_  ***********
//
#pragma	interrupt HighISR
void	HighISR(void)
{
	if (PIR1bits.TMR1IF)
	{
		PIR1bits.TMR1IF = 0 ;
		WriteTimer1(TIMER1_1ms_VALUE);
		FLAG_1ms = 1 ;
	}
}
#pragma code

//*******************************************
//****************  D{  ***************** 
//*******************************************
//
void main(void)
{
	OSCCONbits.IRCF = 0x07 ;		// 	Select INTOSC-8Mhz as clock source
	
	RCONbits.IPEN=1;				// }lBCuv_\
	IPR1bits.TMR1IP=1;				// ]w Timer1 uv_
	INTCONbits.GIEH = 1 ;			// }Ұץv_

	Timer1_Initial( );
	ADC_Initial( );								// 	ToDo : iHվ IRCF 줸ӳ]wu@Wv 
	ADCON1bits.PCFG = 0x0f ;		//	Set all ADC multiplexed pins as digital mode
    OpenLCD();

    putrsLCD((const rom far char*)"    Lab4 ADC    ");
	LCD_Set_Cursor(1,0) ;
	putrsLCD((const rom far char*)"ADC=            ");
   
    while(1)
	{
		if (FLAG_1ms)
		{
			FLAG_1ms = 0 ;
			Timer1_Acc ++ ;
			if ( Timer1_Acc == 200 )	//  C 200mS ഫ AD 
			{
				Timer1_Acc = 0 ;
				SelChanConvADC(ADC_CH0) ;
 				for (i=0;i<=10;i++);     // @pq˹qeRqɶ
				while(BusyADC()) ;
				Update_ADC(ReadADC()) ;
			}
		}

	}	
}


void Update_ADC(unsigned int ADC_Value)
{
	LCD_Set_Cursor(1,4);
	putrsLCD((const rom far char*)"            ");			// SOഫ,b Compiler ɷ|@ Warning !!
	LCD_Set_Cursor(1,4);
	itoa(ADC_Value,ASCII_Buffer) ;
	putsLCD(ASCII_Buffer);
	putrsLCD((const rom far char*)" :0x");
	puthexLCD(ADC_Value>>8);
	puthexLCD(ADC_Value&0xFF);

}

//
//***** ]w Timer1 l{
//
void Timer1_Initial(void)
{
		WriteTimer1(TIMER1_1ms_VALUE);
		OpenTimer1(	TIMER_INT_ON & T1_16BIT_RW &\
					T1_SOURCE_INT & T1_PS_1_1 & \
					T1_OSC1EN_OFF & T1_SYNC_EXT_OFF ) ;
}
//
//***** ]w ADC l{
//
void ADC_Initial(void)
{
//
//  ] VR1 ϥ 0V ~ 5V qJAҥH ADC Ѧҹq]ϥ
//   +5V & 0V Ѧҹq
//
		OpenADC( 	ADC_FOSC_16 & ADC_RIGHT_JUST & ADC_4_TAD ,
					ADC_CH0 & ADC_INT_OFF & ADC_REF_VDD_VSS ,
					ADC_1ANA); 
}